#ifdef __cplusplus
extern "C" {
#endif
  
#include <pthread.h>

#include "../pcmu_l.h"
#include "../error.h"

#ifndef NO_VIAVOICE
#include <eci.h>
#endif
  
#ifdef __cplusplus
}
#endif

#include <string>

#ifdef NO_VIAVOICE
typedef void *ECIHand;
#endif


/****GLOBALS*********/
// #define BUFFER_SIZE 160

enum simv_system_status { 
SIMV_NORMAL,
SIMV_CALL_PEND,
SIMV_HU_PEND
};

/* ASR: Silence detection energy threshold */
#define VAT_THRESHOLD 260000000.0
#define SILENCE_DURATION_SEC 1
#define MAX_UTT_SEC 5 
#define MAX_ASR_LENGTH 1024

/* TTS: Buffer specification */ 
#define SEND_BUF_SIZE 800
#define MAX_MSG_SIZE 800

/* RTP: Payload type */
#define PT_MULAW_8 0

/* RTP: Max. size of UDP pkt */
#define RECV_BUF_SIZE 65536

#ifdef NAOYA
/*
 * NetTtsAsrTool
 * Encapusulates RTP Session, TTS and ASR 
 * functionalities 
 * Naoya Seta
 */
class NetTtsAsrTool
{
public:
  /*  Constructor */ 
  NetTtsAsrTool(){ }

  /* Destructor */
  ~NetTtsAsrTool(){ }

  void StartTool();
  void StopTool();

  /**
   * Callback to indicate receiving pound
   * meaning the end of talk spurt
   */
  void SetRtpInfo(simv_info_t & rtp); 

  /**
   * Callback to indicate receiving pound
   * meaning the end of talk spurt
   */
  virtual int OnReceivePound(SIPInstantMessageInfo & iminfo);

  char *tts_buffer; 
  char *asr_buffer; 

private:
  simv_info_t *rtp;
}

#endif
