#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include <sys/soundcard.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define BUF_SIZE 4096
#define BYTE_PER_SMPL 2
#define PLAY_UNIT 960

int main(int argc, char *argv[])
{

  int au, rcnt;
  FILE *data_fp;
  /* AFMT_MU_LAW, AFMT_S16_LE
  */
  int format = AFMT_S16_LE, stereo = 0, speed = 8000, duplex = 1;
  u_char buf[BUF_SIZE];

  if(argc < 2){
    fprintf( stdout, "Usage: %s <file>\n", argv[0]);
    exit(-1);
  }

  if(!(data_fp = fopen(argv[1], "r"))){
    fprintf( stderr, "Can't open file %s\n", argv[1]);
    exit(-1);
  }

  if((au = open("/dev/dsp", O_RDWR, NULL)) < 0){
    perror("open audio device");
    exit( -1);
  }
  if(ioctl(au, SNDCTL_DSP_SETFMT, &format) == -1){
    perror("SETFMT");
    exit( -1);
  }
  if(ioctl(au, SNDCTL_DSP_STEREO, &stereo) == -1){
    perror("STEREO");
    exit( -1);
  }
  if(ioctl(au, SNDCTL_DSP_SPEED, &speed) == -1){
    perror("SPEED");
    exit( -1);
  }
  if(ioctl(au, SNDCTL_DSP_SETDUPLEX, &duplex) == -1){
    perror("SETDUPLEX");
    exit( -1);
  }

  rcnt = fread(buf, PLAY_UNIT*BYTE_PER_SMPL, 1, data_fp);
  while(rcnt){

      write(au, buf, PLAY_UNIT*BYTE_PER_SMPL);

      /* Read audio data */
      rcnt = fread(buf, PLAY_UNIT*BYTE_PER_SMPL, 1, data_fp);
  }

  close(au);
  fclose(data_fp);

  fprintf( stderr, "Play finished\n");
}
