#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>

#define BUF_SIZE 8192

int main( int argc, char *argv[]){

  int au;
  int format = AFMT_MU_LAW, stereo=0, speed=8000, duplex=1;
  int rcnt=0;
  u_char buffer[BUF_SIZE];


  if( (au=open("/dev/audio", O_RDWR, NULL)) < 0){
    perror("open audio device");
    exit( -1);
  }
  if(ioctl(au, SNDCTL_DSP_SETFMT, &format) == -1){
    perror("SETFMT");
    exit( -1);
  }
  if(ioctl(au, SNDCTL_DSP_STEREO, &stereo) == -1){
    perror("STEREO");
    exit( -1);
  }
  if(ioctl(au, SNDCTL_DSP_SPEED, &speed) == -1){
    perror("SPEED");
    exit( -1);
  }
  if(ioctl(au, SNDCTL_DSP_SETDUPLEX, &duplex) == -1){
    perror("SETDUPLEX");
    exit( -1);
  }

  while(1){
    rcnt = read(au, buffer, 8000);
    write(au, buffer, rcnt);
  }
  
  return 0;
}

